/*
 * List_ListInsert.c --
 *
 *	Codigo fuente del procedimiento de libreria List_ListInsert.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#include <stdlib.h>
#include <bwcc.h>
#include "list.h"

/*
 * ----------------------------------------------------------------------------
 *
 * List_ListInsert --
 *
 *	Inserta la lista apuntada por headerPtr en una Lista y a continuacion
 *	de destPtr.
 *
 * Resultados:
 *	Ninguno.
 *
 * Efectos Laterales:
 *	La lista que contiene destPtr es modificada para que contenga a
 *	itemPtr.
 * 	HeaderPtr ya no referenciara a una lista valida.
 *
 * ----------------------------------------------------------------------------
 */
void
List_ListInsert(headerPtr, destPtr)
    register	List_Links *headerPtr;	/* estructura a insertar */
    register	List_Links *destPtr;	/* Estructura tras la cual vamos a
					 * insertarlo. */
{
    extern char far salidas[199];
    if (headerPtr == (List_Links *) NIL || destPtr == (List_Links *) NIL
	    || !headerPtr || !destPtr) {
	/* ***panic*** */
	wsprintf(salidas,"List_ListInsert: headerPtr (%x) or destPtr (%x) is NIL.\nTerminating.",
		  (unsigned long int) headerPtr, (unsigned long int) destPtr);
	BWCCMessageBox(GetFocus(), salidas, "Fatal Error", MB_OK | MB_ICONSTOP | MB_SYSTEMMODAL);
	exit(-1);
	return;
    }

    if (headerPtr->nextPtr != headerPtr) {
	headerPtr->prevPtr->nextPtr = destPtr->nextPtr;
	headerPtr->nextPtr->prevPtr = destPtr;
	destPtr->nextPtr->prevPtr = headerPtr->prevPtr;
	destPtr->nextPtr = headerPtr->nextPtr;
    }

    headerPtr->nextPtr = (List_Links *) NIL;
    headerPtr->prevPtr = (List_Links *) NIL;
}
