/*
 * Hash_FindEntry.c --
 *
 *	Codigo fuente para el procedimiento de libreria Hash_FindEntry.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#include "hash.h"
#include "list.h"

/*
 * Procedimientos utiles definidos en otros ficheros:
 */

extern Hash_Entry *     HashChainSearch();
extern long int         Hash();

/*
 *---------------------------------------------------------
 *
 * Hash_FindEntry --
 *
 * 	Busca en la tabla hash una entrada correspondiente a una clave (key).
 *
 * Resultados:
 *	El valor de retorno es un puntero a la entrada correspondiente a la
 *	clave proporcionada si diche clave estaba presente en la tabla. Si la
 *	clve no se encuentra en la tabla, se devuelve NULL.
 *
 * Efectos Laterales:
 *	Ninguno.
 *
 *---------------------------------------------------------
 */

Hash_Entry *
Hash_FindEntry(tablePtr, key)
    Hash_Table *tablePtr;	/* Tabla hash en la que buscar. */
    Address key;		/* La clave. */
{
    return(HashChainSearch(tablePtr, key,
	    &(tablePtr->bucketPtr[(unsigned int)Hash(tablePtr, key)])));
}
