/*
 * HashChainSearch.c --
 *
 *	Codigo fuente para HashChainSearch, un procedimiento usado
 *	por la libreria de tablas hash.
 *
 * Copyright 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#include <string.h>
#include "hash.h"
#include "list.h"


/*
 *---------------------------------------------------------
 *
 * HashChainSearch --
 *
 * 	Busca en la tabla hash la entrada que se proporciona.
 *
 * Resultados:
 *	Puntero a la entrada encontrada, NULL si no se encuentra ninguna.
 *
 * Efectos laterales:
 *	Ninguno.
 *
 *---------------------------------------------------------
 */

Hash_Entry *
HashChainSearch(tablePtr, key, hashList)
    Hash_Table 		*tablePtr;	/* Tabla Hash en la que buscar. */
    register Address	key;		/* Una clave hash. */
    register List_Links *hashList;
{
    register Hash_Entry *hashEntryPtr;
    register long int 	*hashKeyPtr;
    long int 		*keyPtr;
    register long int	numKeys;

    numKeys = tablePtr->keyType;
    LIST_FORALL(hashList, (List_Links *) hashEntryPtr) {
	switch (numKeys) {
	    case 0:
		if (strcmp(hashEntryPtr->key.name, key) == 0) {
		    return(hashEntryPtr);
		}
		break;
	    case 1:
		if (hashEntryPtr->key.ptr == key) {
		    return(hashEntryPtr);
		}
		break;
	    case 2:
		hashKeyPtr = hashEntryPtr->key.words;
		keyPtr = (long int *) key;
		if (*hashKeyPtr++ == *keyPtr++ && *hashKeyPtr == *keyPtr) {
		    return(hashEntryPtr);
		}
		break;
	    default:
		hashKeyPtr = hashEntryPtr->key.words;
		keyPtr = (long int *) key;
		if (*hashKeyPtr++ == *keyPtr++ && *hashKeyPtr == *keyPtr) {
		    return(hashEntryPtr);
		}
		break;
/* ***	    default:
		if (!bcmp((char *) hashEntryPtr->key.words,
			    (char *) key, numKeys * sizeof(long int))) {
		    return(hashEntryPtr);
		}
		break;
*** */
	}
    }

    /*
     * La entrada deseada no esta aqui
     */

    return ((Hash_Entry *) NULL);
}
