/*
 * sprite.h --
 *
 * Constantes y declaraciones de tipo comunes para Sprite.
 *
 * Copyright 1985, 1988 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 */

/****************************************************************
 * PROYECTO FINAL DE CARRERA:		        		*
 *	Simulador Vectorial para PC bajo entorno Windows	*
 * 		                                		*
 *      Autor: Roberto Calpe Lorenzo				*
 *                                                              *
 ****************************************************************/

#ifndef _SPRITE
#define _SPRITE

/*
 * Un tipo booleano es definido como un entero, no como enum. Esto permite
 * a un argumento booleano ser una expresion que no sea estrictamente 0 o 1.
 */

#ifndef TRUE
#define TRUE    1L
#endif
#ifndef FALSE
#define FALSE   0L
#endif

#ifndef _ASM
typedef long int Boolead;

/*
 * Funciones que deban devolver un estado pueden devolver un ReturnStatus para
 * indicar exito o el tipo de fallo.
 */

typedef long int  ReturnStatus;
#endif /* _ASM */

/*
 * SUCCESS                      No hubo error.
 * FAILURE                      Hubo un error.
 */

#define SUCCESS                 0x00000000L
#define FAILURE                 0x00000001L


/*
 * Un puntero nil debe ser algo que cause una excepcion si es referenciado.
 * Hay dos nils: el nil del kernel y el nil utilizado por los procesos
 * de usuario.
 */

#define NIL             0xFFFFFFFFL
#define USER_NIL        0L
#ifndef NULL
#define NULL            0L
#endif

#ifndef _ASM
/*
 * Una direccion es unicamente un puntero en C.  Es definida como un puntero
 * a un caracter de manera que la aritmetica que se aplique sobre la direccion
 * funcione correctamente, es decir un byte cada vez.
 */

typedef char *Address;

#ifndef _CLIENTDATA
typedef long int *ClientData;
#define _CLIENTDATA
#endif

#ifndef __STDC__
#define volatile
#define const
#endif
#endif /* _ASM */


#endif /* _SPRITE */
